Attribute VB_Name = "DirectSoundModule"
Option Explicit
Global DirectX As New DirectX8

Global DirectSound As DirectSound8
Global SoundBuffer() As DirectSoundSecondaryBuffer8

Sub DXCreateSound(HWnd As Integer)
'On Error Resume Next
Set DirectSound = DirectX.DirectSoundCreate("")
DirectSound.SetCooperativeLevel HWnd, DSSCL_NORMAL
End Sub

Function DXGetSoundBuffers() As Integer
'On Error Resume Next
DXGetSoundBuffers = UBound(SoundBuffer)
End Function

Sub DXDestroySound()
'On Error Resume Next
Set DirectSound = Nothing
End Sub

Sub DXLoadSound(Buffer As Integer, SoundFile As String, HZ As Integer, Bit As Integer, Channels As Integer)
'On Error Resume Next
Dim BufferDesc As DSBUFFERDESC

BufferDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
BufferDesc.fxFormat.nFormatTag = 1 'WAVE_FORMAT_PCM
BufferDesc.fxFormat.nChannels = Channels
BufferDesc.fxFormat.lSamplesPerSec = HZ
BufferDesc.fxFormat.nBitsPerSample = Bit
BufferDesc.fxFormat.nBlockAlign = BufferDesc.fxFormat.nBitsPerSample / 8 * BufferDesc.fxFormat.nChannels
BufferDesc.fxFormat.lAvgBytesPerSec = BufferDesc.fxFormat.lSamplesPerSec * BufferDesc.fxFormat.nBlockAlign

Set SoundBuffer(Buffer) = DirectSound.CreateSoundBufferFromFile(SoundFile, BufferDesc)
End Sub

Sub DXPlaySound(BufferNum As Integer, PlayMode As Integer)
'On Error Resume Next
SoundBuffer(BufferNum).Play PlayMode
End Sub

Sub DXStopSound(BufferNum As Integer)
'On Error Resume Next
SoundBuffer(BufferNum).Stop
End Sub

Sub DXSetSoundBufferPan(Buffer As Integer, PanVolume As Integer)
'Pan: 0 - 100
'On Error Resume Next
Select Case PanVolume
    Case 0
        SoundBuffer(Buffer).SetPan -10000
    Case 100
        SoundBuffer(Buffer).SetPan 10000
    Case Else
        SoundBuffer(Buffer).SetPan (100 * PanVolume) - 5000
End Select
End Sub

Sub DXSetSoundBuffers(Buffers As Integer)
'On Error Resume Next
ReDim Preserve SoundBuffer(Buffers)
End Sub

Sub DXSetSoundBufferVolume(Buffer As Integer, Volume As Integer)
'Volume: 0 - 100
'On Error Resume Next
SoundBuffer(Buffer).SetVolume (60 * Volume) - 6000
End Sub
